// ================================================================
// Copyright (c) 2004 John Kerl.
// kerl at math dot arizona dot edu
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation; either version 2 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
// details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA  02111-1307  USA
// ================================================================

#include <stdio.h>
#include "tvector.h"
#include "complex_float.h"
#include "complex_double.h"
#include "compare.h"

//int main(void)
//{
//	int n = 10;
//	tvector<float> a(n), b(n);
//	float tol = 1e-2, maxerr, rmserr;
//	int cmprc;
//	for (int i = 0; i < n; i++) {
//		a[i] = (float)i * 3.141592;
//		b[i] = (float)i * 3.1415926;
//	}
//	cmprc = float_vector_compare(
//		a.expose(), b.expose(), n,
//		tol, maxerr, rmserr);
//	printf("n=%d tol=%.4e maxerr=%.4e rmserr=%.4e rc=%d\n",
//		n, tol, maxerr, rmserr, cmprc);
//	return 0;
//}

//int main(void)
//{
//	int n = 10;
//	tvector<double> a(n), b(n);
//	double tol = 1e-2, maxerr, rmserr;
//	int cmprc;
//	for (int i = 0; i < n; i++) {
//		a[i] = (double)i * 3.141592653589;
//		b[i] = (double)i * 3.14159265358979;
//	}
//	cmprc = double_vector_compare(
//		a.expose(), b.expose(), n,
//		tol, maxerr, rmserr);
//	printf("n=%d tol=%.4le maxerr=%.4le rmserr=%.4le rc=%d\n",
//		n, tol, maxerr, rmserr, cmprc);
//	return 0;
//}

//int main(void)
//{
//	int n = 10;
//	tvector<complex_float> a(n), b(n);
//	float tol = 1e-2, maxerr, rmserr;
//	int cmprc;
//	for (int i = 0; i < n; i++) {
//		a[i].re = (float)i * 3.141592;
//		a[i].im = (float)i * 2.7182818;
//		b[i].re = (float)i * 3.1415926;
//		b[i].im = (float)i * 2.71828182845;
//	}
//	cmprc = complex_float_vector_compare(
//		a.expose(), b.expose(), n,
//		tol, maxerr, rmserr);
//	printf("n=%d tol=%.4e maxerr=%.4e rmserr=%.4e rc=%d\n",
//		n, tol, maxerr, rmserr, cmprc);
//	return 0;
//}

int main(void)
{
	int n = 10;
	tvector<complex_double> a(n), b(n);
	double tol = 1e-2, maxerr, rmserr;
	int cmprc;
	for (int i = 0; i < n; i++) {
		a[i].re = (double)i * 3.141592;
		a[i].im = (double)i * 2.7182818;
		b[i].re = (double)i * 3.1415926;
		b[i].im = (double)i * 2.71828182845;
	}
	cmprc = complex_double_vector_compare(
		a.expose(), b.expose(), n,
		tol, maxerr, rmserr);
	printf("n=%d tol=%.4le maxerr=%.4le rmserr=%.4le rc=%d\n",
		n, tol, maxerr, rmserr, cmprc);
	return 0;
}
